/**
 * This class models a mammal.
 * Class Mammal extends class Animal
 * @see Animal
 * @author Yuval Vidal
 */ 
public class Mammal extends Animal{
	protected double milk; //amount of milk in liters
	
	//1 liter of milk = 500 calories
	public final int CAL_IN_MILK=500;
	
	/**A constructor*/ 
	public  Mammal (String name, String gender, double energy, double milk){
		super(name, gender , energy); 
		this.milk = milk; 
	}
	
	//Adds given amount of milk to current amount
	public void setMilk(double milk){
		this.milk+=milk;
	}
	
	//returns the amount of milk a mammal has
	public double getMilk(){
		return this.milk;
	}
	
	/**
	*Transfer all the milk from a given female mammal (mom) to this one
	* Updates amount of milk and energy.
	*/
	public void nurseFrom(Mammal mom) throws WrongGenderException{
		//old implementation
		/*
		if (mom.gender.equals("female")){
			this.energy += mom.milk*CAL_IN_MILK;  
			mom.energy -= mom.milk*CAL_IN_MILK;
			mom.milk = 0;
		}
		*/
		//new implementation
		if (!(mom.gender.equals("female")))
			throw new WrongGenderException("a Mammal can nurse from female only");
		this.energy += mom.milk*CAL_IN_MILK;  
		mom.energy -= mom.milk*CAL_IN_MILK;
		mom.milk = 0;
	}
	
	/**
	 * Transfer all the milk from this female mammal to a given
	 * mammal (baby). Updates amount of milk and energy.
	 */
	 public void nurseSomeone(Mammal baby) throws WrongGenderException{
	 	//old implementation
		/*
		if (this.gender.equals("female")){
	 		baby.energy += this.milk*CAL_IN_MILK;   
	 		this.energy -= this.milk*CAL_IN_MILK;
	 		this.milk = 0;
	 	}
	 	*/
	 	//new implementation
		if (!(this.gender.equals("female")))
			throw new WrongGenderException("a Mammal can nurse from female only");
		baby.energy += this.milk*CAL_IN_MILK;   
	 	this.energy -= this.milk*CAL_IN_MILK;
	 	this.milk = 0;
	 }
	 	 
	 /** @return String - all mammal's fields */
	 public String toString(){
	 	return super.toString()+"milk: "+this.milk+"\n";
	 }
}